#include <stdio.h>

#define MAXN 30

/* Struttura dati che rappresenta una singola iscrizione. */
struct Record {
    int usato; /* vale 0 se questo record e' inutilizzato, 1 altrimenti */
    int matricola;
    int votoScritto;
    int votoPratica;
};

static int inserisci(struct Record* iscr, int m, int vs, int vp)
{
    int i;

    /* Cerca un qualsiasi record inutilizzato. */
    for (i=0; i<MAXN; i++) {
        struct Record *r = &iscr[i];

        if (r->usato == 0) {
            /* Trovato, usiamo questo per memorizzare la nuova iscrizione. */
            r->matricola = m;
            r->votoScritto = vs;
            r->votoPratica = vp;
            r->usato = 1; /* marca come usato */

            return i;
        }
    }

    return -1; /* non ho trovato un record libero */
}

static void stampa(const struct Record iscr[])
{
    int i;

    for(i=0; i < MAXN; i++) {
        if (iscr[i].usato) {
            printf("%d, %d, %d\n", iscr[i].matricola,
                    iscr[i].votoScritto, iscr[i].votoPratica);
        }
    }
}

int main()
{
    struct Record iscr[MAXN]; /* Array che memorizza le iscrizioni */
    int pos;
    int i;

    /* Inizializza i record in modo che siano tutti inutilizzati. */
    for (i=0; i<MAXN; i++) {
        iscr[i].usato = 0;        
    }
  
    pos = inserisci(iscr, 401524, 28, 23);  
    if (pos!=-1) {
        printf("Matricola 401524 Inserita in posizione %d\n", pos);
    } else {
        printf("Vettore pieno, non e' possibile effettuare l'inserimento\n");
    }

    pos = inserisci(iscr, 204658, 30, 28);
    if (pos!=-1) {
        printf("Matricola 204658 Inserita in posizione %d\n", pos);
    } else {
        printf("Vettore pieno, non e' possibile effettuare l'inserimento\n");
    }

    pos = inserisci(iscr, 345998, 20, 18);
    if (pos!=-1) {
        printf("Matricola 345998 Inserita in posizione %d\n", pos);
    } else {
        printf("Vettore pieno, non e' possibile effettuare l'inserimento\n");
    }

    pos = inserisci(iscr, 420202, 25, 19);
    if (pos!=-1) {
      printf("Matricola 420202 Inserita in posizione %d\n", pos);
    } else {
      printf("Vettore pieno, non e' possibile effettuare l'inserimento\n");
    }

    pos = inserisci(iscr, 375877, 27, 26);
    if (pos!=-1) {
      printf("Matricola 375877 Inserita in posizione %d\n", pos);
    } else {
        printf("Vettore pieno, non e' possibile effettuare l'inserimento\n");
    }

    /* Stampa l'array. */
    stampa(iscr);

    return 0;
}
